/*
 * Copyright (C) 2025, Stephan Mueller <smueller@chronox.de>
 *
 * License: see LICENSE file in root directory
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, ALL OF
 * WHICH ARE HEREBY DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF NOT ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

#ifndef X448_SCALARMULT_H
#define X448_SCALARMULT_H

#include "lc_x448.h"

#ifdef __cplusplus
extern "C" {
#endif

int x448_derive_public_key(uint8_t out[LC_X448_PUBLICKEYBYTES],
			   const uint8_t scalar[LC_X448_SECRETKEYBYTES]);
int x448_scalarmult(uint8_t out[LC_X448_PUBLICKEYBYTES],
		    const uint8_t base[LC_X448_PUBLICKEYBYTES],
		    const uint8_t scalar[LC_X448_SECRETKEYBYTES]);

#ifdef __cplusplus
}
#endif

#endif /* X448_SCALARMULT_H */
